package dev.pfaff.altargui.pathfinder;

import dev.pfaff.altargui.debug.TimingSite;
import dev.pfaff.altargui.debug.TimingSites;
import dev.pfaff.altargui.types.Color;

import static dev.pfaff.altargui.GuiGlobals.GL;
import static dev.pfaff.altargui.internal.Config.FONT_FAMILY;
import static dev.pfaff.altargui.internal.Config.PATHFINDER_SCENE_PROXY_EXECUTOR;
import static dev.pfaff.log4truth.format.Format.STANDARD_DURATION;

/**
 * This does not work. I've left it here to be fixed in the future.
 */
public final class PathfinderDemo {
	private static final PFRendererLevel RENDER_MODE = PFRendererLevel.PF_RENDERER_LEVEL_D3D9;

	public static final Pathfinder PATHFINDER = new Pathfinder(GL.symbolLookup());

	private static final PFGLDeviceRef device = PATHFINDER.createDevice(PFGLVersion.PF_GL_VERSION_GL3);
	private static final PFResourceLoaderRef resourceLoader = PATHFINDER.createEmbeddedResourceLoader();
	public static final PFGLRendererRef pfRenderer = PFGLRendererRef.create(device,
			resourceLoader,
			RENDER_MODE,
			new PFGLDestFramebufferInit.FullWindow(800, 600));
	private static final PFCanvasFontContextRef fontContext = PATHFINDER.createSystemFontContext();
	private static final PFBuildOptionsRef options = PATHFINDER.createBuildOptions();
//	private static final PFCanvasRef canvas = PATHFINDER.createCanvas(fontContext, WIDTH, HEIGHT);
//	private static final PFSceneRef scene = canvas.createScene();
//	private static final PFSceneProxyRef sceneProxy = scene.createProxy(RENDER_MODE);

	//	private static final PFFillStyleRef colorBlue = PFFillStyleRef.createColor(Color.fromRgba(0, 0, 255, 255));
	private static final PFFillStyleRef colorWhite = PFFillStyleRef.createColor(Color.WHITE);
//	private static final PFFillStyleRef colorWhite = PFFillStyleRef.createColor(Color.TRANSPARENT);
//	private static final PFFillStyleRef colorDark = PFFillStyleRef.createColor(Color.fromRgba(255, 0, 255, 255));

	private static final PFSceneProxyRef sceneProxy = switch (PATHFINDER_SCENE_PROXY_EXECUTOR) {
		case Sequential -> PFSceneProxyRef.createWithSequentialExecutor(RENDER_MODE);
		case Rayon -> PFSceneProxyRef.createWithRayonExecutor(RENDER_MODE);
	};

	private static final FKFontRef font = fontContext.getFontByPostscriptName(FONT_FAMILY);

	public static void render(float width, float height) {
//		while (true) {
//			GuiGlobals.GL.glClearColor(0f, 0f, 0f, 0f);
//			GuiGlobals.GL.glClear(0x4000);

		var canvas = PATHFINDER.createCanvas(fontContext, width, height);

//		canvas.clear();
//		canvas.setFillStyle(colorWhite);
//		canvas.fillRect(0f, 0f, 200, 100);
//			canvas.setFillStyle(colorBlue);
		canvas.setFillStyle(colorWhite);
//			canvas.fillRect(4f, 4f, 20f, 20f);
//			canvas.setFillStyle(colorWhite);
		canvas.setFont(font);
		var fontSize = 24f;
		canvas.setFontSize(fontSize);
//		canvas.fillText("Hello from Pathfinder", 4f, 4f + fontSize);
//		canvas.fillText("Hello from Pathfinder", 4f, 4f + fontSize + 2f + fontSize);

		drawMostRecentTiming(canvas, TimingSites.FRAME, width, fontSize, 1);
		drawMostRecentTiming(canvas, TimingSites.TICK, width, fontSize, 2);

		sceneProxy.replaceScene(canvas.takeScene());

//		GL.glFinish();
//		GL.glDisable(GLEnableCap.DEPTH_TEST);
//		GL.glDepthMask(false);
//		GL.glDisable(GLEnableCap.BLEND);

		sceneProxy.buildAndRenderGL(pfRenderer, options);

//			GL.gl.glFlush();
//			GuiGlobals.GL.glFinish();
//			mcWindow.swapBuffers();
//			GuiGlobals.GL.glFinish();
//			try {
//				Thread.sleep(2000);
//			} catch (InterruptedException e) {
//				throw new RuntimeException(e);
//			}
//		}
	}

	private static void drawMostRecentTiming(PFCanvasRef canvas, TimingSite timingSite, float width, float fontSize, float lineNumber) {
		var lastFrameTime = STANDARD_DURATION.nanosToString(timingSite.getLastElapsed());
		var strWidth = canvas.measureText(lastFrameTime);
		canvas.fillText(lastFrameTime, width - strWidth - 4f, 2f + (2f + fontSize) * lineNumber);
	}
}
